package datascen_pac;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigDecimal;

/* Parent class */

public class Datasc_en {
    public static void main(String[] args) {

	System.out.println("WAV/AIFF Data Size Caluculator");
	System.out.println("Ver 1.0.0 by Akihiro Hori /tobiuo music avenue");

	int i = 0;

while( i < 10 ) {
        i++;

        Datasc01 k01 = new Datasc01();
        k01.main01();

        i--;
		}

    }
}


/* Input sample rate */

class Datasc01 {
  void main01(){

	InputStreamReader iar = new InputStreamReader(System.in);
	BufferedReader br = new BufferedReader(iar);

	System.out.println("");
	System.out.print("Input sample rate(Hz) numerical value. (11025`384000):");

	try {

		String kb1 = br.readLine();

		long val1 = 0;  /* Input sample rate numecal initialize */

		val1 = Integer.parseInt(kb1);

		if ( val1 > 384000 ){
			System.out.println("Invalid numerical value.(Valid numerical value is less than 384000Hz.");


    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val1 < 11025 ){
			System.out.println("Invalid numerical value.(Valid numerical value is 11025Hz and over.");

			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("Entered sample rate numerical is " + val1 + " Hz.");

/* Display bitrate */

	System.out.print("Input bit rate(bit) numerical value. (4`128):");

	try {

		String kb2 = br.readLine();

		long val2 = 0;  /* Input bit rate initialize */

		val2 = Integer.parseInt(kb2);

		if ( val2 > 128 ){
			System.out.println("Invalid numerical value.(Valid numerical value is less than 128bit.");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val2 < 4 ){
			System.out.println("Invalid numerical value.(Valid numerical value is 4bit and over.");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("Entered bit rate numerical is " + val2 + " bit.");

/* Display channel numecal */

	System.out.print("Input recording channel numerical value. (1`10):");

	try {

		String kb3 = br.readLine();

		long val3 = 0;  /* Input channel numecal initialize */

		val3 = Integer.parseInt(kb3);

		if ( val3 > 10 ){
			System.out.println("Invalid numerical value.(Valid numerical value is less than 10ch.");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val3 < 1 ){
			System.out.println("Invalid numerical value.(Valid numerical value is 1ch and over.");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("Entered recording channel numerical is " + val3 + " ch.");

/* Input time numecal */

	System.out.print("Input recording time(sec) numerical value. (1`36000):");

	try {

		String kb4 = br.readLine();

		long t1 = 0;  /* Input time numecal initialize */

		t1 = Integer.parseInt(kb4);

		if ( t1 > 36000 ){
			System.out.println("Invalid numerical value.(Valid numerical value is less than 36000(10 hour).");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( t1 < 1 ){
			System.out.println("Invalid numerical value.(Valid numerical value is 1sec and over.");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("Entered recording time numerical is " + t1 + " sec.");
		System.out.println("");


		/* Display at data size per one second */

		System.out.println("");
		System.out.println("");
		System.out.println("[" + val1 + "Hz] [" + val2 + "bit] [" + val3 + "ch] In the setting mentioned above,");
		System.out.println("calculate about [" + t1 + "sec] recorded WAV/AIFF file.");
		System.out.println("");

		long val4 = (val1 * val2 * val3);
		System.out.println("Audio data size per one second is " + val4 + " bit(bps).");

		BigDecimal bdv01 = new BigDecimal(val4).divide(new BigDecimal("8.0"));
		BigDecimal bdv02 = bdv01.setScale(3, BigDecimal.ROUND_HALF_UP);
		System.out.println("Unit conversion. Byte is " + bdv02 + " Byte/sec.");


		BigDecimal bdv03 = bdv02.divide(new BigDecimal("1024.0"));
		BigDecimal bdv04 = bdv03.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdv03.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("Kibibyte numecal is less than 1KiB/sec.");
		} else {
			System.out.println("Kibibyte numecal is " + bdv04 + " KiB/sec.");
		}

		BigDecimal bdv05 = bdv04.divide(new BigDecimal("1024.0"));
		BigDecimal bdv06 = bdv05.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdv06.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("Mebibyte numecal is less than 1MiB/sec.");
		} else {
			System.out.println("mebibyte numecal is " + bdv06 + " MiB/sec.");
		}

		System.out.println("");


		/* Display at file size */

		long t2 = ( t1 * val4 );
		System.out.println("File size in WAV/AIFF is " + t2 + " bit.");

		BigDecimal bdt01 = new BigDecimal(t2).divide(new BigDecimal("8.0"));
		BigDecimal bdt02 = bdt01.setScale(3, BigDecimal.ROUND_HALF_UP);
		System.out.println("Unit conversion. Byte is " + bdt02 + " Byte.");

		BigDecimal bdt03 = bdt02.divide(new BigDecimal("1024.0"));
		BigDecimal bdt04 = bdt03.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt03.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("Kibibyte numecal is less than 1KiB.");
		} else {
			System.out.println("Kibibyte numecal is " + bdt04 + " KiB.");
		}

		BigDecimal bdt05 = bdt04.divide(new BigDecimal("1024.0"));
		BigDecimal bdt06 = bdt05.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt06.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("Mebibyte numecal is less than 1MiB.");
		} else {
			System.out.println("Mebibyte numecal is " + bdt06 + " MiB.");
		}

		BigDecimal bdt07 = bdt06.divide(new BigDecimal("1024.0"));
		BigDecimal bdt08 = bdt07.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt08.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("Gibibyte numecal is less than 1GiB.");
		} else {
			System.out.println("Gibibyte numecal is " + bdt08 + " GiB.");
		}


		System.out.println("");
		//System.exit(0);


	} catch (IOException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	} catch (NumberFormatException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	}

	} catch (IOException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	} catch (NumberFormatException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	}


	} catch (IOException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	} catch (NumberFormatException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	}


	} catch (IOException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	} catch (NumberFormatException e) {
		System.out.println("Invalid numerical value. Exit to program.");
		System.exit(0);
	}

  }
}




